/***************************************************************************
 *   Copyright (C) 2007 by                                       *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef acs_H
#define acs_H

#include "ui_acs.h"
#include <tango.h>
#include <QProcess>
#include <QSettings>
		
class acs: public QWidget
{
    Q_OBJECT

public:
    acs(QWidget * =NULL);
    ~acs();

public slots:
    void refresh();
    void open_inA0_list();
    void open_inA1_list();
    void open_staff_list();
    void open_linac_doors();
    void open_e0_doors();
    void open_e1_doors();
    void open_e2_doors();
    void open_e3_doors();
    void open_tl_doors();
    void open_emergency_buttons();
    void open_bst_linac_panel();
    void open_stat_linac_shutdown();
    void open_stat_linac_off();
    void open_stat_linac_on();
    void open_klyswitch();
    void open_klystat();
    void open_search_panel();
    void open_permission_panel();
    void open_plants_panel();
    void open_map();
    void open_map_panel();
    void open_hardware_panel();
    void open_version_panel();
    void open_alarmlist_panel();
    void open_rfpcgun_panel();
    void open_rfinhibit_panel();
    void open_A0door();
    void open2_A0door();
    void close_A0door();
    void open_A1door();
    void a0Restore();
    void a1Restore();
    void watchRequest();
    void open_topup_error();
    void emergencyRestore();
    void open_bst_linac();
    void close_bst_linac();
    void switch_master();
    void open_bstinfo_panel();
    void open_bst11info_panel();
    void open_bst12info_panel();
    void open_bst13info_panel();
    void open_bst14info_panel();
    void open_scrapersinfo_panel();
    void switch_control_location();

private:
    Ui::acs ui;
    bool master, masterA0, masterA1;
    QTimer *timer;
    QProcess *inA0_list_process;
    QProcess *inA1_list_process;
    QProcess *staff_list_process;
    QProcess *bst_process;
    QProcess *linac_doors_process;
    QProcess *e0_doors_process;
    QProcess *e1_doors_process;
    QProcess *e2_doors_process;
    QProcess *e3_doors_process;
    QProcess *tl_doors_process;
    QProcess *rfpcgun_process;
    QProcess *rfinhibit_process;
    QProcess *bstinfo_process;
    QProcess *bst11info_process;
    QProcess *bst12info_process;
    QProcess *bst13info_process;
    QProcess *bst14info_process;
    QProcess *bst_linac_process;
    QProcess *stat_shutdown_process;
    QProcess *stat_off_process;
    QProcess *stat_on_process;
    QProcess *klyswitch_process;
    QProcess *klystat_process;
    QProcess *search_process;
    QProcess *emergency_buttons_process;
    QProcess *topup_error_process;
    QProcess *map_process;
    QProcess *hardware_process;
    QProcess *permission_process;
    QProcess *plants_process;
    QProcess *scrapersinfo_process;
    QProcess *alarmlist_process;
    int myReadShortint(const char *, short int *);
    int myReadBool(const char *, bool *);
    int myReadBoolArray(const char *, vector<bool> &);
    int myReadString(const char *, string &);
    int myReadShortArray(const char *, vector<short> &);
    int myReadAttribute(const char *);
    int myWriteCommand(const char *);
    int mySetColor(QFrame *, const char *, QPalette::ColorRole);
    int mySetTextColor(QLabel *, const char *, const char *);
    int mySetTextColor(QLabel *, const char *, const char *, const char *);
    int refreshCount;
    int map;
    bool plcstat;
    Tango::DeviceAttribute myAttribute;
    Tango::DeviceProxy 	*plc_server;
    QPixmap door_big_open, door_big_closed;
    QString imgpath;
    QString style;
    QString controlLocation;

};


#endif
